<template>
  <div class="base-filepicker">

    <h6 class="base-filepicker__title">Загрузить фото</h6>
    <span class="base-filepicker__label">Вы можете загрузить не более 5 фото весом не более 10 Мб каждое.</span>

    <div class="base-filepicker__row">
      <perfect-scrollbar class="base-filepicker__images"
                         v-if="base64Files.length"
      >
          <div class="base-filepicker__image"
               v-for="(file, index) in base64Files"
               :key="index"
               :data-file-id="file.id"
          >
            <img :src="file.img" alt="">
            <div class="base-filepicker__remove-image" @click="removeFile">
              <icon-cross />
            </div>
          </div>
      </perfect-scrollbar>

      <label v-if="base64Files.length < 5"
             for="file"
             class="base-filepicker__btn">
        <icon-plus />
        Добавить фото
      </label>
      <input type="file" name="file" id="file"
             multiple
             maxlength="5"
             accept="image/jpeg"
             @change="onChange">
    </div>
  </div>

</template>

<script>
  import { PerfectScrollbar } from 'vue2-perfect-scrollbar';
  import 'vue2-perfect-scrollbar/dist/vue2-perfect-scrollbar.css';

  import IconPlus from './icons/IconPlus';
  import IconCross from './icons/IconCross';

  export default {
    name: 'BaseFilepicker',
    components: {
      IconCross,
      PerfectScrollbar,
      IconPlus
    },
    props: {
      files: {
        type: Array,
        required: true,
      }
    },
    data: () => ({
      blobFiles: [],
      base64Files: [],
      hasFileApi: false,
      maxFiles: 5,
      id: 0,
    }),
    mounted() {
      this.hasFileApi = !!( window.File && window.FileReader && window.FileList && window.Blob );
    },
    methods: {
      onChange(event) {
        const files = event.target.files;
        const filesArr = Array.from(files);
        const filesLength = this.files.length;

        if (!this.hasFileApi) return;

        filesArr.forEach((file, index) => {
          if (file.type !== 'image/jpeg') {
            this.$notify({
              group: 'errors',
              type: 'error',
              title: 'Ошибка',
              text: 'Можно загрузить только jpeg изображения',
            });

            return;
          }

          if (file.size > 10 * 1024 * 1024) {
            this.$notify({
              group: 'errors',
              type: 'error',
              title: 'Ошибка',
              text: 'Максимальный вес файла - 10 мб',
            });

            return
          }

          if ((filesLength + index) > 4 || this.files.length > 5) {
            this.$notify({
              group: 'errors',
              type: 'error',
              title: 'Ошибка',
              text: 'Можно загрузить не более 5 изображений',
            });

            return;
          };


          this.$emit('addFile', { id: this.id, file });
          const reader = new FileReader();
          reader.readAsDataURL(file);
          reader.onload = () => {
            this.base64Files.push({ id: this.id, name: file.name, img: reader.result });
            this.id++;
          };
        });

        event.target.value = '';
      },

      removeFile(event) {
        const fileId = event.target.closest('[data-file-id]').dataset.fileId;

        this.$emit('removeFile', fileId);
        this.base64Files = this.base64Files.filter((file) => Number(file.id) !== Number(fileId));
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .base-filepicker {
    input[type="file"] {
      display: none;
    }


    &__title {
      @include p1;

      margin-bottom: rem(6);
      color: rgba($black, .4);
    }

    &__label {
      @include p3;
    }

    &__row {
      display: flex;
      align-items: center;

      margin-top: rem(20);

      @media (max-width: $mobile-width) {
        flex-flow: column;
      }
    }

    &__images {
      flex-grow: 1;
      flex-shrink: 1;

      display: flex;

      @media (max-width: $mobile-width) {
        width: 100%;
      }

      & + .base-filepicker__btn {
        margin-left: rem(14);

        @media (max-width: $mobile-width) {
          margin-left: 0;
          margin-top: rem(14);
        }
      }
    }

    &__image {
      &:not(:first-child) {
        margin-left: rem(14);
      }

      flex-grow: 0;
      flex-shrink: 0;
      flex-basis: rem(109);
      width: rem(109);
      height: rem(64);

      border-radius: rem(4);
      overflow: hidden;

      &:hover {
        .base-filepicker__remove-image {
          opacity: 1;
        }
      }

      img {
        width: 100%;
        height: 100%;

        object-fit: cover;
        object-position: center;
      }
    }

    &__remove-image {
      position: absolute;
      top: 0;
      right: 0;

      width: rem(22);
      height: rem(22);
      padding: rem(4);

      opacity: 0;
      transition: opacity .25s;
      cursor: pointer;

      svg {
        width: rem(10);
        height: rem(10);

        stroke: $white
      }
    }

    &__btn {
      @include gray-btn;
      @include bold-black-link;

      display: flex;
      align-items: center;
      justify-content: center;

      flex-shrink: 0;
      flex-grow: 0;
      flex-basis: rem(234);
      width: rem(234);
      height: rem(64);

      border-radius: rem(8);
      cursor: pointer;

      @media (max-width: $mobile-width) {
        flex-basis: auto;
        width: 100%;
      }

      svg {
        width: rem(12);
        height: rem(12);

        margin-right: rem(10);
      }

      &:active {
        @include gray-btn-active;
      }
    }
  }
</style>
